## uhub 0.3.2

=== debian/changelog ===
uhub (0.3.2-1) unstable; urgency=low

  * Initial release (closes: #643290).

 -- Boris Pek <tehnick-8@mail.ru>  Sat, 08 Oct 2011 18:03:02 +0300
