=== debian/rules ===
#!/usr/bin/make -f

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

ifeq (,$(NUMJOBS))
	NUMJOBS = 1
endif

PACKAGE = uhub
DEVELOPER = janvidar
PROJECT = uhub

CUR_VER = $(shell dpkg-parsechangelog | sed -ne 's/^Version: \(\([0-9]\+\):\)\?\(.*\)-.*/\3/p')

MAKEOPTS := DESTDIR=$(CURDIR)/debian/uhub/ \
            UHUB_PREFIX=$(CURDIR)/debian/uhub/usr \
            RELEASE=YES

build: build-arch build-indep

build-arch: build-stamp

build-indep: build-stamp

build-stamp:
	dh_testdir
	$(MAKE) -j$(NUMJOBS) $(MAKEOPTS)
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	$(MAKE) clean
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) install $(MAKEOPTS)
	chmod 0750 $(CURDIR)/debian/uhub/var/log/uhub

get-orig-source:
	# preparation
	rm -rf  "$(CUR_VER)"/ "$(PACKAGE)-$(CUR_VER)"/
	# sources
	wget -4 "http://nodeload.github.com/$(DEVELOPER)/$(PROJECT)/tarball/$(CUR_VER)"
	rm -rf $(DEVELOPER)-$(PROJECT)-*
	tar xzf "$(CUR_VER)"
	mv $(DEVELOPER)-$(PROJECT)-* "$(PACKAGE)-$(CUR_VER)"
	# tarball
	tar -cjf "$(PACKAGE)_$(CUR_VER).orig.tar.bz2" "$(PACKAGE)-$(CUR_VER)"
	# cleaning
	rm -rf "$(PACKAGE)-$(CUR_VER)" "$(CUR_VER)"

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installinit
	dh_installlogrotate
	dh_installman -A
	dh_installchangelogs ChangeLog
	dh_strip
	dh_lintian
	dh_compress
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch

.PHONY: build clean binary-indep binary-arch binary install
