=== debian/watch ===
version=3
https://github.com/janvidar/uhub/tags .*/janvidar/uhub/tarball/(\d.+) debian uupdate
