## uhub 0.4.1

=== debian/changelog ===
uhub (0.4.1-3) unstable; urgency=low

  * Move package to unstable: no changes required.

 -- Boris Pek <tehnick-8@mail.ru>  Sun, 12 May 2013 20:09:49 +0300

uhub (0.4.1-2) experimental; urgency=low

  * Add file debian/patches/fix-build-on-hurd-i386:
    fix build in Debian GNU/Hurd.

 -- Boris Pek <tehnick-8@mail.ru>  Tue, 20 Nov 2012 22:44:22 +0200

uhub (0.4.1-1) experimental; urgency=low

  * Update to stable release 0.4.1.
  * Delete debian/patches/*: accepted in upstream.
  * Update debian/rules and debian/watch: fix after recent changes in GitHub.

 -- Boris Pek <tehnick-8@mail.ru>  Wed, 07 Nov 2012 23:42:52 +0200

uhub (0.4.0+git20121013-55-g7fae42a-2) experimental; urgency=low

  * Add debian/patches/fix-build-on-kfreebsd:
    fix build in Debian GNU/kFreeBSD.

 -- Boris Pek <tehnick-8@mail.ru>  Sun, 14 Oct 2012 02:20:16 +0300

uhub (0.4.0+git20121013-55-g7fae42a-1) experimental; urgency=low

  * Update to Git snapshot.
  * Update debian/control:
    add build dependency from cmake.
  * Update debian/rules:
    upstream uses CMake now instead of manually written Makefile.
  * Update debian/uhub.lintian-overrides:
    false positives for lintian tag hardening-no-fortify-functions.
  * Bump debhelper version to 8 (was 7.0.50~); update debian/compat.

 -- Boris Pek <tehnick-8@mail.ru>  Sat, 13 Oct 2012 23:14:27 +0300

uhub (0.4.0-1) experimental; urgency=low

  * Update to stable release 0.4.0.
  * Delete debian/doc/uhub-passwd.1: now available in upstream.
  * Update debian/uhub.manpages: see above.
  * Update debian/rules:
    - simplify rules
    - enable verbose output during build
    - fix get-orig-source section in according with Debian Policy §4.9

 -- Boris Pek <tehnick-8@mail.ru>  Wed, 30 May 2012 23:42:48 +0300

uhub (0.4.0~git20120423-9efe4bc-1) experimental; urgency=low

  * Update to GIT snapshot.
  * Bumped Standards-Version to 3.9.3.
  * Changed tarball compression format: LZMA2 is used now.
  * debian/rules was updated:
    - now dh is used instead of direct dh_* commands
    - now uscan is used for checking current upstream version
      (dpkg-parsechangelog was used earlier)
    - USE_SSL configuration option is enabled
    - used hardening flags in compiler options
  * debian/doc/uhub.1, debian/doc/uhub.conf and debian/doc/users.conf
    were removed: now they are available in upstream.
  * debian/doc/uhub-passwd.1 was created: there is no such man page in
    upstream yet.
  * debian/uhub.manpages was updated (see above).
  * debian/control was updated: added dependence from packages
    fakeroot, libsqlite3-dev and libssl-dev
  * debian/copyright was updated:
    - URL in Format field was updated
    - years were updated
    - OpenSSL exception was officially received
      (see file COPYING.OpenSSL in sources)
  * Upstream possibly fixed build for hurd-i386,
    kfreebsd-i386, kfreebsd-amd64, s390 and s390x.

 -- Boris Pek <tehnick-8@mail.ru>  Mon, 23 Apr 2012 23:53:57 +0300
