=== debian/control ===
--- 
+++ 
@@ -2,11 +2,12 @@
 Section: net
 Priority: optional
 Maintainer: Boris Pek <tehnick-8@mail.ru>
-Build-Depends: debhelper (>= 7)
+Build-Depends: debhelper (>= 8), cmake (>= 2.8.3), fakeroot,
+ libsqlite3-dev, libssl-dev
 Homepage: http://www.uhub.org/
 Vcs-Git: git://github.com/tehnick/uhub-debian.git
 Vcs-Browser: https://github.com/tehnick/uhub-debian
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 
 Package: uhub
 Architecture: any
@@ -22,6 +23,6 @@
  Key features:
   - High performance and low memory usage
   - IPv4 and IPv6 support
-  - Experimental SSL support (optional)
+  - Experimental SSL support
   - Advanced access control support
   - Easy configuration
