=== debian/watch ===
version=3
https://github.com/janvidar/uhub/tags .*/janvidar/uhub/archive/(\d.+)\.tar\.gz debian uupdate
