=== debian/changelog ===
uhub (0.5.1-1) unstable; urgency=medium

  * New upstream version
    Closes: #871436
  * New upstream location
    Closes: #971652
  * d/watch
     - Point to new upstream
     - Version = 5
  * Maintain package in Salvage team
    Closes: #1116710
  * d/rules: Cleanup from unneeded and redundant things
  * Standards-Version: 4.7.2 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Secure URI in copyright format (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Update lintian override info format in d/uhub.lintian-overrides
  * Add service file
    Closes: #1039402
  * Fix build using CMake 4
    Closes: #1113598
  * Remove outdated information from d/copyright
  * Drop fakeroot from Build-Depends
  * Drop unneeded tags from lintian-overrides
  * d/rules: hardening flags

 -- Andreas Tille <tille@debian.org>  Mon, 20 Oct 2025 11:16:57 +0200

uhub (0.4.1-3.3) unstable; urgency=medium

  * Non-maintainer upload.
  [ zhangdandan <zhangdandan@loongson.cn> ]
  * Add support for LoongArch (Closes: #1074428)

  [ Zixing Liu <zixing.liu@canonical.com> ]
  * Fix FTBFS with newer gcc (Closes: #1066247)
  * Fix FTBFS with riscv64 (Closes: #1020965)
    - patch contributed by Eric Long <i@hack3r.moe>

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 05 Nov 2024 07:38:55 +0100

uhub (0.4.1-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Add arm64-fix-ftbfs.patch to fix FTBFS on arm64. (Closes: #770175)

 -- Emanuele Rocca <ema@debian.org>  Mon, 12 Sep 2022 11:14:29 +0200

uhub (0.4.1-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Bumped DH level to 10.
  * Bumped Standards-Version to 3.9.8.
  * patches/openssl1.1.patch: added to provide compatibility with OpenSSL 1.1.
    Thanks to Reiner Herrmann <reiner@reiner-h.de>. (Closes: #828583)

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Fri, 23 Dec 2016 02:27:45 -0200
