=== debian/control ===
Source: uhub
Standards-Version: 4.7.2
Maintainer: Package Salvaging Team <team+salvage@tracker.debian.org>
Uploaders:
 Boris Pek <tehnick-8@mail.ru>,
 Andreas Tille <tille@debian.org>
Section: net
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libsqlite3-dev,
 libssl-dev,
Vcs-Browser: https://salsa.debian.org/salvage-team/uhub
Vcs-Git: https://salsa.debian.org/salvage-team/uhub.git
Homepage: https://github.com/modelrockettier/uhub

Package: uhub
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: High performance Advanced Direct Connect p2p hub
 uhub is a high performance peer-to-peer hub for the ADC network.
 Its low memory footprint allows it to handle several thousand users on
 high-end servers, or a small private hub on embedded hardware.
 .
 uhub uses the Advanced Direct Connect protocol, and is compatible with
 DC++, LinuxDC++, EiskaltDC++ and other ADC clients.
 .
 Key features:
  - High performance and low memory usage
  - IPv4 and IPv6 support
  - Experimental SSL support
  - Advanced access control support
  - Easy configuration
