=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	rm -f $(CURDIR)/src/version.h

override_dh_auto_install:
	dh_auto_install
	chmod 0750 $(CURDIR)/debian/`dh_listpackages`/var/log/uhub
