=== debian/watch ===
Version: 5

Template: Github
Owner: modelrockettier
Project: @PACKAGE@
